export const ConfusionGroup = ({
  data,
  height,
  xScale,
  xSelector,
  yScale,
  ySelector,
  matrix_size,
  num_classes,
  cell_width,
  x_loc,
  y_loc,
  color_scale,
  labels,
  hoveredValue,
  fadeOpacity,
}) => (
  <g>
    //vertical ticks
    <text
      x={x_loc - 0.8*cell_width}
      y={y_loc + cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(-30,296.2,336)'}
    >
      {labels[0]}
    </text>
    <text
      x={x_loc - 1.4 * cell_width}
      y={y_loc + 2.3 * cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(-30,274.6,382.8)'}
    >
      {labels[1]}
    </text>
    <text
      x={x_loc - 0.9*cell_width}
      y={y_loc + 3 * cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(-30,292.6,408)'}
    >
      {labels[2]}
    </text>
    <text
      x={x_loc - 1.7 * cell_width}
      y={y_loc + 4.5 * cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(-30,263.8,462)'}
    >
      {labels[3]}
    </text>
    <text
      x={x_loc - cell_width / 2}
      y={y_loc + 4.6 * cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(-30,309,465.6)'}
    >
      {labels[4]}
    </text>
    //Axis labels
    <text
      x={x_loc + 5*cell_width+5}
      y={y_loc + 2.5*cell_width}
      fill={'black'}
      textAnchor="middle"
      transform={'rotate(90,510,390)'}
    >
      {'True'}
    </text>
    <text
      x={x_loc + 2.5*cell_width}
      y={y_loc - 5}
      fill={'black'}
      textAnchor="middle"
    >
      {'Predicted'}
    </text>
    //frame
    <rect
      width={matrix_size}
      height={matrix_size}
      x={x_loc}
      y={y_loc}
      stroke="black"
      fill="none"
    />
    //first row
    <g opacity={hoveredValue == "Data Analyst" ? 1 : fadeOpacity}>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc}
      y={y_loc}
      stroke="black"
      fill={color_scale(
        data[0]['val'] /
          (data[0]['val'] +
            data[1]['val'] +
            data[2]['val'] +
            data[3]['val'] +
            data[4]['val'])
      )}
    />
    <text
      x={x_loc + cell_width / 2}
      y={y_loc + cell_width / 1.75}
      fill={'white'}
      textAnchor="middle"
    >
      {data[0]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + cell_width}
      y={y_loc}
      stroke="black"
      fill={color_scale(
        data[1]['val'] /
          (data[0]['val'] +
            data[1]['val'] +
            data[2]['val'] +
            data[3]['val'] +
            data[4]['val'])
      )}
    />
    <text
      x={x_loc + (3 * cell_width) / 2}
      y={y_loc + cell_width / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[1]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 2 * cell_width}
      y={y_loc}
      stroke="black"
      fill={color_scale(
        data[2]['val'] /
          (data[0]['val'] +
            data[1]['val'] +
            data[2]['val'] +
            data[3]['val'] +
            data[4]['val'])
      )}
    />
    <text
      x={x_loc + (5 * cell_width) / 2}
      y={y_loc + cell_width / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[2]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 3 * cell_width}
      y={y_loc}
      stroke="black"
      fill={color_scale(
        data[3]['val'] /
          (data[0]['val'] +
            data[1]['val'] +
            data[2]['val'] +
            data[3]['val'] +
            data[4]['val'])
      )}
    />
    <text
      x={x_loc + (7 * cell_width) / 2}
      y={y_loc + cell_width / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[3]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 4 * cell_width}
      y={y_loc}
      stroke="black"
      fill={color_scale(
        data[4]['val'] /
          (data[0]['val'] +
            data[1]['val'] +
            data[2]['val'] +
            data[3]['val'] +
            data[4]['val'])
      )}
    />
    <text
      x={x_loc + (9 * cell_width) / 2}
      y={y_loc + cell_width / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[4]['val']}
    </text>
    </g>
    //second row
    <g  opacity={hoveredValue == "Data Science Manager" ? 1 : fadeOpacity}>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc}
      y={y_loc + cell_width}
      stroke="black"
      fill={color_scale(
        data[5]['val'] /
          (data[5]['val'] +
            data[6]['val'] +
            data[7]['val'] +
            data[8]['val'] +
            data[9]['val'])
      )}
    />
    <text
      x={x_loc + cell_width / 2}
      y={y_loc + (2.75 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[5]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + cell_width}
      y={y_loc + cell_width}
      stroke="black"
      fill={color_scale(
        data[6]['val'] /
          (data[5]['val'] +
            data[6]['val'] +
            data[7]['val'] +
            data[8]['val'] +
            data[9]['val'])
      )}
    />
    <text
      x={x_loc + (3 * cell_width) / 2}
      y={y_loc + (2.75 * cell_width) / 1.75}
      fill={'white'}
      textAnchor="middle"
    >
      {data[6]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 2 * cell_width}
      y={y_loc + cell_width}
      stroke="black"
      fill={color_scale(
        data[7]['val'] /
          (data[5]['val'] +
            data[6]['val'] +
            data[7]['val'] +
            data[8]['val'] +
            data[9]['val'])
      )}
    />
    <text
      x={x_loc + (5 * cell_width) / 2}
      y={y_loc + (2.75 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[7]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 3 * cell_width}
      y={y_loc + cell_width}
      stroke="black"
      fill={color_scale(
        data[8]['val'] /
          (data[5]['val'] +
            data[6]['val'] +
            data[7]['val'] +
            data[8]['val'] +
            data[9]['val'])
      )}
    />
    <text
      x={x_loc + (7 * cell_width) / 2}
      y={y_loc + (2.75 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[8]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 4 * cell_width}
      y={y_loc + cell_width}
      stroke="black"
      fill={color_scale(
        data[9]['val'] /
          (data[5]['val'] +
            data[6]['val'] +
            data[7]['val'] +
            data[8]['val'] +
            data[9]['val'])
      )}
    />
    <text
      x={x_loc + (9 * cell_width) / 2}
      y={y_loc + (2.75 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[9]['val']}
    </text>
    </g>
    //third row
    <g  opacity={hoveredValue == "Data Scientist" ? 1 : fadeOpacity}>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc}
      y={y_loc + 2 * cell_width}
      stroke="black"
      fill={color_scale(
        data[10]['val'] /
          (data[10]['val'] +
            data[11]['val'] +
            data[12]['val'] +
            data[13]['val'] +
            data[14]['val'])
      )}
    />
    <text
      x={x_loc + cell_width / 2}
      y={y_loc + (4.5 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[10]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + cell_width}
      y={y_loc + 2 * cell_width}
      stroke="black"
      fill={color_scale(
        data[11]['val'] /
          (data[10]['val'] +
            data[11]['val'] +
            data[12]['val'] +
            data[13]['val'] +
            data[14]['val'])
      )}
    />
    <text
      x={x_loc + (3 * cell_width) / 2}
      y={y_loc + (4.5 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[11]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 2 * cell_width}
      y={y_loc + 2 * cell_width}
      stroke="black"
      fill={color_scale(
        data[12]['val'] /
          (data[10]['val'] +
            data[11]['val'] +
            data[12]['val'] +
            data[13]['val'] +
            data[14]['val'])
      )}
    />
    <text
      x={x_loc + (5 * cell_width) / 2}
      y={y_loc + (4.5 * cell_width) / 1.75}
      fill={'white'}
      textAnchor="middle"
    >
      {data[12]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 3 * cell_width}
      y={y_loc + 2 * cell_width}
      stroke="black"
      fill={color_scale(
        data[13]['val'] /
          (data[10]['val'] +
            data[11]['val'] +
            data[12]['val'] +
            data[13]['val'] +
            data[14]['val'])
      )}
    />
    <text
      x={x_loc + (7 * cell_width) / 2}
      y={y_loc + (4.5 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[13]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 4 * cell_width}
      y={y_loc + 2 * cell_width}
      stroke="black"
      fill={color_scale(
        data[14]['val'] /
          (data[10]['val'] +
            data[11]['val'] +
            data[12]['val'] +
            data[13]['val'] +
            data[14]['val'])
      )}
    />
    <text
      x={x_loc + (9 * cell_width) / 2}
      y={y_loc + (4.5 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[14]['val']}
    </text>
    </g>
    //fourth row
    <g  opacity={hoveredValue == "Machine Learning Engineer" ? 1 : fadeOpacity}>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc}
      y={y_loc + 3 * cell_width}
      stroke="black"
      fill={color_scale(
        data[15]['val'] /
          (data[15]['val'] +
            data[16]['val'] +
            data[17]['val'] +
            data[18]['val'] +
            data[19]['val'])
      )}
    />
    <text
      x={x_loc + cell_width / 2}
      y={y_loc + (6.3 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[15]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + cell_width}
      y={y_loc + 3 * cell_width}
      stroke="black"
      fill={color_scale(
        data[16]['val'] /
          (data[15]['val'] +
            data[16]['val'] +
            data[17]['val'] +
            data[18]['val'] +
            data[19]['val'])
      )}
    />
    <text
      x={x_loc + (3 * cell_width) / 2}
      y={y_loc + (6.3 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[16]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 2 * cell_width}
      y={y_loc + 3 * cell_width}
      stroke="black"
      fill={color_scale(
        data[17]['val'] /
          (data[15]['val'] +
            data[16]['val'] +
            data[17]['val'] +
            data[18]['val'] +
            data[19]['val'])
      )}
    />
    <text
      x={x_loc + (5 * cell_width) / 2}
      y={y_loc + (6.3 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[17]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 3 * cell_width}
      y={y_loc + 3 * cell_width}
      stroke="black"
      fill={color_scale(
        data[18]['val'] /
          (data[15]['val'] +
            data[16]['val'] +
            data[17]['val'] +
            data[18]['val'] +
            data[19]['val'])
      )}
    />
    <text
      x={x_loc + (7 * cell_width) / 2}
      y={y_loc + (6.3 * cell_width) / 1.75}
      fill={'white'}
      textAnchor="middle"
    >
      {data[18]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 4 * cell_width}
      y={y_loc + 3 * cell_width}
      stroke="black"
      fill={color_scale(
        data[19]['val'] /
          (data[15]['val'] +
            data[16]['val'] +
            data[17]['val'] +
            data[18]['val'] +
            data[19]['val'])
      )}
    />
    <text
      x={x_loc + (9 * cell_width) / 2}
      y={y_loc + (6.3 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[19]['val']}
    </text>
    </g>
    //fifth row
    <g  opacity={hoveredValue == "Others" ? 1 : fadeOpacity}>
        <rect
      width={cell_width}
      height={cell_width}
      x={x_loc}
      y={y_loc + 4 * cell_width}
      stroke="black"
      fill={color_scale(
        data[20]['val'] /
          (data[20]['val'] +
            data[21]['val'] +
            data[22]['val'] +
            data[23]['val'] +
            data[24]['val'])
      )}
    />
    <text
      x={x_loc + cell_width / 2}
      y={y_loc + (8.1 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[20]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + cell_width}
      y={y_loc + 4 * cell_width}
      stroke="black"
      fill={color_scale(
        data[21]['val'] /
          (data[20]['val'] +
            data[21]['val'] +
            data[22]['val'] +
            data[23]['val'] +
            data[24]['val'])
      )}
    />
    <text
      x={x_loc + (3 * cell_width) / 2}
      y={y_loc + (8.1 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[21]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 2 * cell_width}
      y={y_loc + 4 * cell_width}
      stroke="black"
      fill={color_scale(
        data[22]['val'] /
          (data[20]['val'] +
            data[21]['val'] +
            data[22]['val'] +
            data[23]['val'] +
            data[24]['val'])
      )}
    />
    <text
      x={x_loc + (5 * cell_width) / 2}
      y={y_loc + (8.1 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[22]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 3 * cell_width}
      y={y_loc + 4 * cell_width}
      stroke="black"
      fill={color_scale(
        data[23]['val'] /
          (data[20]['val'] +
            data[21]['val'] +
            data[22]['val'] +
            data[23]['val'] +
            data[24]['val'])
      )}
    />
    <text
      x={x_loc + (7 * cell_width) / 2}
      y={y_loc + (8.1 * cell_width) / 1.75}
      fill={'black'}
      textAnchor="middle"
    >
      {data[23]['val']}
    </text>
    <rect
      width={cell_width}
      height={cell_width}
      x={x_loc + 4 * cell_width}
      y={y_loc + 4 * cell_width}
      stroke="black"
      fill={color_scale(
        data[24]['val'] /
          (data[20]['val'] +
            data[21]['val'] +
            data[22]['val'] +
            data[23]['val'] +
            data[24]['val'])
      )}
    />
    <text
      x={x_loc + (9 * cell_width) / 2}
      y={y_loc + (8.1 * cell_width) / 1.75}
      fill={'white'}
      textAnchor="middle"
    >
      {data[24]['val']}
    </text>
    </g>
  </g>
);
