import { Dmarks } from './Dmarks';

export const DescriptionGroup = ({
  hoveredValue,
  data,
  xScale,
  xValue,
  yScale,
  yValue,
  posValue,
  colorScale,
  colorValue,
  circleRadius,
  centroids,
  filteredData,
  fadeOpacity,
}) => (
  <g>
    <text
          className="axis-label"
          textAnchor="left"
          x={5}
          y={20}
        >
          {'Description'}
        </text>
        <text
          className="axis-label"
          textAnchor="left"
          x={5}
          y={40}
        >
          {'TSNE'}
        </text>
    <g opacity={hoveredValue ? fadeOpacity : 1}>
      <Dmarks
        data={data}
        xScale={xScale}
        xValue={xValue}
        yScale={yScale}
        yValue={yValue}
        posValue={posValue}
        colorScale={colorScale}
        colorValue={colorValue}
        circleRadius={circleRadius}
      />
      <g>
        // Centroid text labels
        <rect
          x={
            xScale(centroids[0]['description_tsne_1']) - 35
          }
          y={
            yScale(centroids[0]['description_tsne_2']) - 25
          }
          width={70}
          height={13}
          fill={'white'}
        />
        <text
          className="centroid-label"
          textAnchor="middle"
          x={xScale(centroids[0]['description_tsne_1'])}
          y={yScale(centroids[0]['description_tsne_2'])-15}
          fill={'green'}
        >
          {centroids[0]['position']}
        </text>
        <rect
          x={
            xScale(centroids[1]['description_tsne_1']) - 35
          }
          y={
            yScale(centroids[1]['description_tsne_2']) - 10
          }
          width={70}
          height={13}
          fill={'white'}
        />
        <text
          className="centroid-label"
          textAnchor="middle"
          x={xScale(centroids[1]['description_tsne_1'])}
          y={yScale(centroids[1]['description_tsne_2'])}
          fill={'darkBlue'}
        >
          {centroids[1]['position']}
        </text>
        <rect
          x={
            xScale(centroids[2]['description_tsne_1']) - 60
          }
          y={
            yScale(centroids[2]['description_tsne_2']) - 10
          }
          width={120}
          height={13}
          fill={'white'}
        />
        <text
          className="centroid-label"
          textAnchor="middle"
          x={xScale(centroids[2]['description_tsne_1'])}
          y={yScale(centroids[2]['description_tsne_2'])}
          fill={'red'}
        >
          {centroids[2]['position']}
        </text>
        <rect
          x={
            xScale(centroids[3]['description_tsne_1']) - 70
          }
          y={
            yScale(centroids[3]['description_tsne_2']) - 20
          }
          width={140}
          height={13}
          fill={'white'}
        />
        <text
          className="centroid-label"
          textAnchor="middle"
          x={xScale(centroids[3]['description_tsne_1'])}
          y={yScale(centroids[3]['description_tsne_2'])-10}
          fill={'darkOrange'}
        >
          {centroids[3]['position']}
        </text>
        <rect
          x={
            xScale(centroids[4]['description_tsne_1']) - 20
          }
          y={
            yScale(centroids[4]['description_tsne_2']) - 10
          }
          width={40}
          height={13}
          fill={'white'}
        />
        <text
          className="centroid-label"
          textAnchor="middle"
          x={xScale(centroids[4]['description_tsne_1'])}
          y={yScale(centroids[4]['description_tsne_2'])}
          fill={'purple'}
        >
          {centroids[4]['position']}
        </text>
      </g>
    </g>
    <Dmarks
      data={filteredData}
      xScale={xScale}
      xValue={xValue}
      yScale={yScale}
      yValue={yValue}
      posValue={posValue}
      colorScale={colorScale}
      colorValue={colorValue}
      circleRadius={circleRadius}
    />
  </g>
);
